/**
*   @file boundary_cut.h
*   @brief this header file contains all necessary
*   functions to perform the boundary mask to thenn 
*	blend the patch under construction into the
*	synthesized image.
*
*   @author Lara Raad
*
*   @date   24/06/2014
*/
#ifndef  BOUNDARY_CUT_H_
#define  BOUNDARY_CUT_H_

#include "common.h"
#include "mt.h"
#include "quilting_lib.h"

int cumulative_vertical_error(Image *out_im, Image src_im, Image *E, Image *paths, int ps, int os, int x, int y, Corner patch_src);

int cumulative_horizontal_error(Image *out_im, Image src_im, Image *E, Image *paths, int ps, int os, int x, int y, Corner patch_src);

int compute_boundary_mask(Image src_im, Image out_im, Image *boundary_mask, int os, int ps, Corner * temp, Corner patch_src, unsigned int *seed);

int create_vertical_mask(Image *E_V, int ps, int os, Image *boundary_mask, Image paths_V, unsigned int *seed);

int create_horizontal_mask(Image *E_H, int ps, int os, Image *boundary_mask, Image paths_H, unsigned int *seed);

int create_Lshape_mask(Image *E_V, Image *E_H, int ps, int os, Image *boundary_mask, Image paths_V, Image paths_H, unsigned int *seed);

#endif