/**
*   @file quilting_lib.h
*   @brief this header file contains all basic functions.
*
*   @author Lara Raad
*
*   @date   24/05/2012
*/

#ifndef  IMAGE_PROCESS_H_
#define  IMAGE_PROCESS_H_

#include <fftw3.h>
#include "common.h"
#include "mt.h"

Image initialize(Image src_img, int block_sz, int overlap_sz, int blocks_row, int blocks_col, Corner *patch_src);
void initialize_image(Image *im, int rows, int cols, int channels);
void initialize_image_D(Image_D *im, int rows, int cols, int channels);
void initialize_image_LD(Image_LD *im, int rows, int cols, int channels);
void initialize_image_UI(Image_UI *im, int rows, int cols, int channels);
void create_position_map(Image position_map);
int crop_image(Image *im_crop, Image *im, int M, int N, int C);
int update_synth_map(Image * synth_map, Image * position_map, Corner * leftTopCorner_src, Corner * leftTopCorner_output, int patch_sz, Image boundary_mask);
char* remove_ext_filename(char *filename);
int im_fft(float *img, fftwl_complex *fft_im, int h, int w);

#endif
